import { area, select, csv, scaleLinear, max, extent, scalePoint, axisLeft, axisBottom,
       format, scaleTime} from 'd3';

const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');



const render = data => {
  
  const title = "A week in San Francisco"
  
  const xValue = d => d.timestamp
  const xAxisLable = 'hello'
  
  const yValue = d => d.temperature
  const yAxisLabel = "label"
  
  const margin = {bottom:70, top:50, left:200, right:20}
  const innerWidth = width - margin.left - margin.right
  const innerHeight = height - margin.top - margin.bottom
  const circleRadius = 7
  
  
  
  const xScale = scaleTime()
								.domain(extent(data,xValue))
   							.range([0,innerWidth])
  								.nice()
  
  const yScale = scaleLinear()
  		.domain(extent(data, yValue))
  		.range([innerHeight,0]).nice()
  		
  			
  
  const xAxisFormat = num => format('.3s')(num).replace('G','B')
  
  const yAxis = axisLeft(yScale)
  							.tickSize(-innerWidth)
  				
  const xAxis = axisBottom(xScale).tickFormat(xAxisFormat)
  							.tickSize(-innerHeight).tickPadding(20)
  
  const g = svg.append('g')
  						 .attr('transform', `translate(${margin.left},${margin.top})`)
  
   				const yAxisG = g.append('g').call(yAxis)
    						
                 
                 yAxisG.selectAll('.domain').remove()
  
    			yAxisG.append('text')
          .attr('class','axisX')
          .text(yAxisLabel).attr('fill','black')
  								.attr('x','-150').attr('y','-70')
  							.attr('transform', `rotate(-90)`)

  				
  							
 const xAxisG = g.append('g').call(xAxis)
  							.attr('transform', `translate(0,${innerHeight})`)
 
 							xAxisG
  							.select('.domain').remove()
  
  			xAxisG.append('text')
          .attr('class','axisX')
          .text(xAxisLable).attr('fill','black')
  								.attr('x',innerWidth/2).attr('y','60')
  
    

  
  g.selectAll('circle').data(data)
  		.enter().append('circle')
  	.attr('cy',d => yScale(yValue(d)) + 2)
  	.attr('cx', d => xScale(xValue(d)))
  	.attr('r', circleRadius)
  
  g.append('text')
           .text(title)
  					.attr('y','-20')
  					.attr('x','300')

}
  

csv('https://vizhub.com/curran/datasets/temperature-in-san-francisco.csv')
  .then(data => {
  data.forEach(d => {
					d.timestamp = new Date(d.timestamp);
    			d.temperature = +d.temperature
    console.log(d.timestamp)
  })
  render(data)
})







